/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief Common Exception Definitions
 */

#include "config.h"

#include <cstdio>

#include <ScaleStack/Common/Exception.h>

namespace ScaleStack
{

namespace Common
{

Exception::Exception(const char* context, const char* message) throw()
{
  snprintf(_message, SCALESTACK_MAX_MESSAGE_SIZE, "[%s] %s", context, message);
}

const char* Exception::what() const throw() 
{
  return _message;
}

} /* namespace Common */

} /* namespace ScaleStack */
