/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief Common Function Object Declarations
 */

#ifndef SCALESTACK_COMMON_FUNCTIONOBJECTS_H
#define SCALESTACK_COMMON_FUNCTIONOBJECTS_H

namespace ScaleStack
{

namespace Common
{

/**
 * Function object to use with containers of pointers when the objects should
 * be deleted.
 */
class DeletePointer
{
public:
  template<typename T>
  void operator()(const T* pointer) const
  {
    delete pointer;
  }
};

} /* namespace Common */

} /* namespace ScaleStack */

#endif /* SCALESTACK_COMMON_FUNCTIONOBJECTS_H */
