/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief Echo Server Module Definitions
 */

#include "config.h"

#include <ScaleStack/EchoServer/Service.h>
#include <ScaleStack/Kernel/Core.h>
#include <ScaleStack/Kernel/Module.h>

using namespace std;
using namespace ScaleStack;

static void options(Kernel::Module& module)
{
  SocketTCP::ListenerOptions(module, "7");
}

static void start(Kernel::Module& module)
{
  EchoServer::Service* service = new EchoServer::Service(module);
  try
  {
    module.getCore().addService("EchoServer", service);
  }
  catch (exception&)
  {
    delete service;
    throw;
  }
}

static void stop(Kernel::Module& module)
{
  delete module.getCore().removeService("EchoServer");
}

SCALESTACK_KERNEL_MODULE(options, start, stop, NULL, NULL);
