/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief Echo Server Service Definitions
 */

#include "config.h"

#include <ScaleStack/EchoServer/Connection.h>
#include <ScaleStack/EchoServer/Service.h>

namespace ScaleStack
{

namespace EchoServer
{

/*
 * Public functions.
 */

Service::Service(Kernel::Module& module):
  SocketTCP::ConnectionService(module),
  _listener_service(module, *this)
{
}

Service::~Service()
{
  _listener_service.shutdown();
  shutdown();
}

SocketTCP::Connection* Service::addConnection(void)
{
  return new Connection(*this);
}

void Service::removeConnection(SocketTCP::Connection* connection)
{
  delete connection;
}

} /* namespace EchoServer */

} /* namespace ScaleStack */
