/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief TestModuleGrandParent Module Definitions
 */

#include "config.h"

#include <cassert>

#include <ScaleStack/Kernel/Core.h>
#include <ScaleStack/Kernel/Module.h>

using namespace ScaleStack;

static void options(Kernel::Module& module)
{
  assert(module.isLoaded() == true);
}

static void start(Kernel::Module& module)
{
  assert(module.getName() == "Kernel::TestModuleGrandParent");
  assert(module.getPathname() != "");
  assert(module.getVersion() == "TestModuleGrandParent Version");
  assert(module.getAuthor() == "TestModuleGrandParent Author");
  assert(module.getTitle() == "TestModuleGrandParent Title");
  assert(module.getLicense() == "TestModuleGrandParentLicense");
  assert(module.getDependencies() == "");
  assert(module.getParentCount() == 0);
  assert(module.isLoaded() == true);
}

static void stop(Kernel::Module& module)
{
  assert(module.isLoaded() == true);
}

static void run(Kernel::Module& module)
{
  assert(module.isLoaded() == true);
  module.getCore().shutdown();
}

static void reconfigure(Kernel::Module& module)
{
  assert(module.isLoaded() == true);
}

SCALESTACK_KERNEL_MODULE(options, start, stop, run, reconfigure);
