/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief TestModuleParent Module Definitions
 */

#include "config.h"

#include <cassert>

#include <ScaleStack/Kernel/Core.h>
#include <ScaleStack/Kernel/Module.h>

using namespace ScaleStack;

static void start(Kernel::Module& module)
{
  assert(module.getName() == "Kernel::TestModuleParent");
  assert(module.getPathname() != "");
  assert(module.getVersion() == "TestModuleParent Version");
  assert(module.getAuthor() == "TestModuleParent Author");
  assert(module.getTitle() == "TestModuleParent Title");
  assert(module.getLicense() == "TestModuleParentLicense");
  assert(module.getDependencies() == "Kernel::TestModuleGrandParent");
  assert(module.getParentCount() == 1);
  assert(module.isLoaded() == true);

  Kernel::Module& parent = module.getCore().getModule("Kernel::TestModuleGrandParent");
  assert(parent.getTitle() == "TestModuleGrandParent Title");
  assert(parent.isLoaded() == true);
}

SCALESTACK_KERNEL_MODULE(NULL, start, NULL, NULL, NULL);
