/*
 * Scale Stack
 *
 * Copyright (C) 2010 Eric Day (eday@oddments.org)
 * All rights reserved.
 *
 * Use and distribution licensed under the BSD license. See the
 * COPYING file in the root project directory for full text.
 */

/**
 * @file
 * @brief Basic application to run generic Scale Stack instance.
 */

#include <exception>
#include <iostream>

#include <ScaleStack/Kernel/Core.h>

int main(int argc, const char* argv[])
{
  ScaleStack::Kernel::Core core;

  try
  {
    /* We use libevent as the default Event service. */
    core.addModuleOptionValue("EventService", "", "EventLibevent");

    /* The first argv entry is the execution filename, so skip it. */
    core.parseArguments(argc - 1, argv + 1);

    core.setSignalHandlers();
    core.run();
  }
  catch (std::exception& e)
  {
    std::cout << e.what() << std::endl;
    return 1;
  }

  return 0;
}
